
bool showInterface = false;

void RenderMenu() {
    if (GetApp() is null) {showInterface = false; return;}
    if (cast<CGameCtnEditorFree>(GetApp().Editor) is null) {showInterface = false; return;}
    if (colorDisplayName) {
        if (UI::MenuItem("\\$29e" + Icons::Random + "\\$f66 Altered Campaign Helper\\$z", "", showInterface)) {
            showInterface = !showInterface;
        }
    } else {
        if (UI::MenuItem("\\$29e" + Icons::Random + "\\$z Altered Campaign Helper", "", showInterface)) {
            showInterface = !showInterface;
        }
    }
}

const vec2 buttonSize = vec2(Math::Floor(20. * UI::GetScale()), Math::Floor(20. * UI::GetScale()));


uint currentTab = 0;
vec4 surfaceColor = vec4(0, 0.5, 0, 1), listColor = vec4(0.5, 0.5, 0, 1), miscColor = vec4(0.5, 0, 0.5, 1);//, clubColor = vec4(0, 0, 0.9, 1);
void RenderInterface() {
    if (!showInterface) {return;}
    if (GetApp() is null) {showInterface = false; return;}
    if (cast<CGameCtnEditorFree>(GetApp().Editor) is null) {showInterface = false; return;}

    UI::SetNextWindowPos(100, 100, UI::Cond::Once);
    switch (currentTab) {
    case 0:
        UI::SetNextWindowSize(300, 0, UI::Cond::Always);
        break;
    case 1:
        UI::SetNextWindowSize(300, 0, UI::Cond::Always);
        break;
    case 2:
       UI::SetNextWindowSize(300, 0, UI::Cond::Always);
        break;
    default:
       UI::SetNextWindowSize(300, 0, UI::Cond::Always);
        break;
    }

    if (UI::Begin("Altered Campaign Helper", showInterface, UI::WindowFlags::NoResize)) {
        UI::BeginTabBar("HUH who uses more than 1 tab bar?", UI::TabBarFlags::NoCloseWithMiddleMouseButton);
        UI::PushStyleColor(UI::Col::Tab, surfaceColor * vec4(0.5, 0.5, 0.5, 0.75));
        UI::PushStyleColor(UI::Col::TabHovered, surfaceColor * vec4(1.2, 1.2, 1.2, 0.85));
        UI::PushStyleColor(UI::Col::TabActive, surfaceColor);
        if (UI::BeginTabItem("Surfaces")) {
            currentTab = 0;
            UI::Text('Select surfaces to highlight');
            if (UI::Button('Refresh')) {
                shouldRefresh = true;
            }
            UI::SameLine();
            UI::Text('' + blocks.Length + ' blocks; ' + highlighted + ' dots');

            bool newValue;
            newValue = UI::Checkbox('Road Tech', RoadTech);
            if (newValue != RoadTech) {
                RoadTech = newValue;
                shouldRefresh = true;}
            newValue = UI::Checkbox('Road Bump', RoadBump);
            if (newValue != RoadBump) {
                RoadBump = newValue;
                shouldRefresh = true;}
            newValue = UI::Checkbox('Platform Tech', PlatformTech);
            if (newValue != PlatformTech) {
                PlatformTech = newValue;
                shouldRefresh = true;}
            newValue = UI::Checkbox('Platform Tech with penalty', OpenTech);
            if (newValue != OpenTech) {
                OpenTech = newValue;
                shouldRefresh = true;}
            UI::Separator();
            newValue = UI::Checkbox('Road Dirt', RoadDirt);
            if (newValue != RoadDirt) {
                RoadDirt = newValue;
                shouldRefresh = true;}
            newValue = UI::Checkbox('Platform Dirt', PlatformDirt);
            if (newValue != PlatformDirt) {
                PlatformDirt = newValue;
                shouldRefresh = true;}
            newValue = UI::Checkbox('Platform Dirt with penalty', OpenDirt);
            if (newValue != OpenDirt) {
                OpenDirt = newValue;
                shouldRefresh = true;}
            UI::Separator();
            newValue = UI::Checkbox('Road Ice', RoadIce);
            if (newValue != RoadIce) {
                RoadIce = newValue;
                shouldRefresh = true;}
            newValue = UI::Checkbox('Platform Ice', PlatformIce);
            if (newValue != PlatformIce) {
                PlatformIce = newValue;
                shouldRefresh = true;}
            newValue = UI::Checkbox('Platform Ice with penalty', OpenIce);
            if (newValue != OpenIce) {
                OpenIce = newValue;
                shouldRefresh = true;}
            UI::Separator();
            newValue = UI::Checkbox('Platform Grass', PlatformGrass);
            if (newValue != PlatformGrass) {
                PlatformGrass = newValue;
                shouldRefresh = true;}
            newValue = UI::Checkbox('Platform Grass with penatly', OpenGrass);
            if (newValue != OpenGrass) {
                OpenGrass = newValue;
                shouldRefresh = true;}
            UI::Separator();
            newValue = UI::Checkbox('Platform Plastic', PlatformPlastic);
            if (newValue != PlatformPlastic) {
                PlatformPlastic = newValue;
                shouldRefresh = true;}
            newValue = UI::Checkbox('Item Plastic', ItemPlastic);
            if (newValue != ItemPlastic) {
                ItemPlastic = newValue;
                shouldRefresh = true;}
            UI::Separator();
            newValue = UI::Checkbox('Road Water', RoadWater);
            if (newValue != RoadWater) {
                RoadWater = newValue;
                shouldRefresh = true;}
            newValue = UI::Checkbox('Platform Water', PlatformWater);
            if (newValue != PlatformWater) {
                PlatformWater = newValue;
                shouldRefresh = true;}
            UI::Separator();
            newValue = UI::Checkbox('Track support (top)', TrackWall);
            if (newValue != TrackWall) {
                TrackWall = newValue;
                shouldRefresh = true;}
            newValue = UI::Checkbox('Platform support (top)', DecoWall);
            if (newValue != DecoWall) {
                DecoWall = newValue;
                shouldRefresh = true;}
            UI::Separator();
            newValue = UI::Checkbox('Boosters', Boosters);
            if (newValue != Boosters) {
                Boosters = newValue;
                shouldRefresh = true;}
            newValue = UI::Checkbox('Effect Blocks', EffectBlocks);
            if (newValue != EffectBlocks) {
                EffectBlocks = newValue;
                shouldRefresh = true;}
            newValue = UI::Checkbox('Checkpoints', IsCheckpoint);
            if (newValue != IsCheckpoint) {
                IsCheckpoint = newValue;
                shouldRefresh = true;}
            newValue = UI::Checkbox('Checkpoints without effect ring', CheckpointNoGate);
            if (newValue != CheckpointNoGate) {
                CheckpointNoGate = newValue;
                shouldRefresh = true;}
            UI::Separator();
            newValue = UI::Checkbox('CPfull alteration', CPfull);
            if (newValue != CPfull) {
                CPfull = newValue;
                shouldRefresh = true;}
            // newValue = UI::Checkbox('Platform to Road without checkpoint overlay', PlatformToRoad_NoCP);
            // if (newValue != PlatformToRoad_NoCP) {
            //     PlatformToRoad_NoCP = newValue;
            //     shouldRefresh = true;}
            newValue = UI::Checkbox('Hole alteration', Hole);
            if (newValue != Hole) {
                Hole = newValue;
                shouldRefresh = true;}
            newValue = UI::Checkbox('Pool hunters*', PoolHunter);
            if (newValue != PoolHunter) {
                PoolHunter = newValue;
                shouldRefresh = true;}
            newValue = UI::Checkbox('Manslaughter*', Manslaughter);
            if (newValue != Manslaughter) {
                Manslaughter = newValue;
                shouldRefresh = true;}
            UI::Separator();
            newValue = UI::Checkbox('Ground mode blocks', Ground);
            if (newValue != Ground) {
                Ground = newValue;
                shouldRefresh = true;}

            UI::EndTabItem();
        }
        UI::PopStyleColor(3);
        UI::PushStyleColor(UI::Col::Tab, listColor * vec4(0.5, 0.5, 0.5, 0.75));
        UI::PushStyleColor(UI::Col::TabHovered, listColor * vec4(1.2, 1.2, 1.2, 0.85));
        UI::PushStyleColor(UI::Col::TabActive, listColor);
        if (UI::BeginTabItem("Highlights list")) {
            currentTab = 1;
            if (UI::Button('Refresh')) {
                shouldRefresh = true;
            }
            UI::SameLine();
            UI::Text('' + blocks.Length + ' blocks; ' + highlighted + ' dots');
            for(uint i = 0; i < blocks.Length; i++) {
                if (!blocks[i].should_display) {continue;}
                if (UI::Button(Icons::Search + '##' + tostring(i), buttonSize)) {FocusCamera(blocks[i].midpoint);}
                UI::SameLine();
                UI::Text('<' + Math::Round(blocks[i].midpoint.x) + ', ' + Math::Round(blocks[i].midpoint.y) + ', ' + Math::Round(blocks[i].midpoint.z) + '> ' + blocks[i].name);
            }
            UI::EndTabItem();
        }
        UI::PopStyleColor(3);
        UI::PushStyleColor(UI::Col::Tab, miscColor * vec4(0.5, 0.5, 0.5, 0.75));
        UI::PushStyleColor(UI::Col::TabHovered, miscColor * vec4(1.2, 1.2, 1.2, 0.85));
        UI::PushStyleColor(UI::Col::TabActive, miscColor);
        if (UI::BeginTabItem("Misc")) {
            currentTab = 2;
            autoColor = UI::Checkbox('###autoColor', autoColor);
            UI::SameLine();
            UI::TextWrapped('Auto select colour when opening a campaign (or altered campaign) map in editor');
            cpWarning = UI::Checkbox('###cpWarning', cpWarning);
            UI::SameLine();
            UI::TextWrapped('Warn if the checkpoint count is different to the unaltered map \n(when entering drive mode)');
            colorDisplayName = UI::Checkbox('###nameColor', colorDisplayName);
            UI::SameLine();
            UI::TextWrapped('Color the name in plugins list');
            UI::Text('Variant highlight mode:');
            if (UI::BeginCombo('##0', VariantColorName(variantColor), UI::ComboFlags::None)) {
                if (UI::Selectable(VariantColorName(VariantColorOptions::Disabled), variantColor == VariantColorOptions::Disabled, UI::SelectableFlags::None)) {
                    variantColor = VariantColorOptions::Disabled;
                }
                if (UI::Selectable(VariantColorName(VariantColorOptions::Ghost), variantColor == VariantColorOptions::Ghost, UI::SelectableFlags::None)) {
                    variantColor = VariantColorOptions::Ghost;
                }
                if (UI::Selectable(VariantColorName(VariantColorOptions::NotGhost), variantColor == VariantColorOptions::NotGhost, UI::SelectableFlags::None)) {
                    variantColor = VariantColorOptions::NotGhost;
                }
                if (UI::Selectable(VariantColorName(VariantColorOptions::Free), variantColor == VariantColorOptions::Free, UI::SelectableFlags::None)) {
                    variantColor = VariantColorOptions::Free;
                }
                if (UI::Selectable(VariantColorName(VariantColorOptions::NotFree), variantColor == VariantColorOptions::NotFree, UI::SelectableFlags::None)) {
                    variantColor = VariantColorOptions::NotFree;
                }
                if (UI::Selectable(VariantColorName(VariantColorOptions::Ground), variantColor == VariantColorOptions::Ground, UI::SelectableFlags::None)) {
                    variantColor = VariantColorOptions::Ground;
                }
                if (UI::Selectable(VariantColorName(VariantColorOptions::NotGround), variantColor == VariantColorOptions::NotGround, UI::SelectableFlags::None)) {
                    variantColor = VariantColorOptions::NotGround;
                }
                if (UI::Selectable(VariantColorName(VariantColorOptions::NotNormal), variantColor == VariantColorOptions::NotNormal, UI::SelectableFlags::None)) {
                    variantColor = VariantColorOptions::NotNormal;
                }
                if (UI::Selectable(VariantColorName(VariantColorOptions::Normal), variantColor == VariantColorOptions::Normal, UI::SelectableFlags::None)) {
                    variantColor = VariantColorOptions::Normal;
                }
                UI::EndCombo();
            }
            checkOverlayHitbox = UI::Checkbox('###overlayhitbox', checkOverlayHitbox);
            UI::SameLine();
            UI::TextWrapped('Require hitbox match on custom overlays (may have issues on support mode tilt/slope blocks)\n(not checked on checkpoints)');
            showDebug = UI::Checkbox('###debugDots', showDebug);
            UI::SameLine();
            UI::TextWrapped('Show debug position dots');


#if GET_CP_DATA
            if (UI::Button('save CP counts')) {
                saveCpCounts();
            }
#endif
            UI::EndTabItem();
        }
        UI::PopStyleColor(3);
        UI::EndTabBar();
    }
    if (shouldRefresh) {
        checkNoFilters();
    }
    UI::End();
}

void FocusCamera(vec3 pos) {
    CGameCtnEditorFree@ editor = cast<CGameCtnEditorFree>(GetApp().Editor);
    CGameControlCameraEditorOrbital@ camera = editor.OrbitalCameraControl;
    if (camera is null) {return;}
    camera.m_TargetedPosition = pos;
    editor.ButtonZoomInOnClick();
    editor.ButtonZoomOutOnClick();
}