
[Setting hidden]
bool RoadTech = false;
[Setting hidden]
bool RoadDirt = false;
[Setting hidden]
bool RoadBump = false;
[Setting hidden]
bool RoadIce = false;
[Setting hidden]
bool RoadWater = false;
[Setting hidden]
bool TrackWall = false;

[Setting hidden]
bool PlatformTech = false;
[Setting hidden]
bool PlatformDirt = false;
[Setting hidden]
bool PlatformIce = false;
[Setting hidden]
bool PlatformGrass = false;
[Setting hidden]
bool PlatformPlastic = false;
[Setting hidden]
bool PlatformWater = false;
[Setting hidden]
bool DecoWall = false;

[Setting hidden]
bool OpenTech = false;
[Setting hidden]
bool OpenDirt = false;
[Setting hidden]
bool OpenIce = false;
[Setting hidden]
bool OpenGrass = false;

[Setting hidden]
bool ItemPlastic = false;

[Setting hidden]
bool Boosters = false;
[Setting hidden]
bool EffectBlocks = false;
[Setting hidden]
bool IsCheckpoint = false;
[Setting hidden]
bool CheckpointNoGate = false;


[Setting hidden]
bool CPfull = false;
[Setting hidden]
bool Hole = false;
[Setting hidden]
bool PoolHunter = false;
[Setting hidden]
bool Manslaughter = false;

[Setting hidden]
bool Ground = false;

/* some blocks check custom block overlays, but many blocks can be skipped at first pickup
 * 0 = skip block, 1 = might highlight (or needed as overlay), 2 = definitely highlight
*/
uint ShouldSaveBlock (CGameCtnBlock@ gameBlock) {
    if (gameBlock.BlockModel.Name == 'Grass') {
        return 0;
    }
    string name = gameBlock.BlockModel.Name;
    if (gameBlock.BlockModel.IdName.EndsWith(".Block.Gbx_CustomBlock")) {
        return 1;
    }
    if (name.Contains('Pillar')) {
        if (Ground && gameBlock.IsGround) {
            return 2;
        }
        return 0;
    }
    if (Ground && gameBlock.IsGround) {
        return 2;
    }

    // currently only set as 1 - if 2 then returned instantly, so also no `Max(min_value, 1)` used
    uint min_value = 0;
    if (RoadTech) {
        if (name.StartsWith('RoadTech')) {
            min_value = 1;
        }
    }
    if (RoadDirt) {
        if (name.StartsWith('RoadDirt')) {
            min_value = 1;
        }
    }
    if (RoadBump) {
        if (name.StartsWith('RoadBump')) {
            min_value = 1;
        }
    }
    if (RoadIce) {
        if (name.StartsWith('RoadIce')) {
            min_value = 1;
        }
    }
    if (RoadWater) {
        if (name.StartsWith('RoadWater')) {
            min_value = 1;
        }
    }
    if (TrackWall) {
        if (name.StartsWith('TrackWall')) {
            return 2;
        }
    }

    if (PlatformTech) {
        if (name.StartsWith('PlatformTech')) {
            return 2;
        }
    }
    if (PlatformDirt) {
        if (name.StartsWith('PlatformDirt')) {
            return 2;
        }
    }
    if (PlatformIce) {
        if (name.StartsWith('PlatformIce')) {
            return 2;
        }
    }
    if (PlatformGrass) {
        if (name.StartsWith('PlatformGrass')) {
            return 2;
        }
    }
    if (PlatformPlastic) {
        if (name.StartsWith('PlatformPlastic')) {
            return 2;
        }
    }
    if (PlatformWater) {
        if (name.StartsWith('PlatformWater')) {
            return 2;
        }
    }
    if (DecoWall) {
        if (name.StartsWith('DecoWall')) {
            return 2;
        }
    }

    if (OpenTech) {
        if (name.StartsWith('OpenTech')) {
            min_value = 1;
        }
    }
    if (OpenDirt) {
        if (name.StartsWith('OpenDirt')) {
            min_value = 1;
        }
    }
    if (OpenIce) {
        if (name.StartsWith('OpenIce')) {
            min_value = 1;
        }
    }
    if (OpenGrass) {
        if (name.StartsWith('OpenGrass')) {
            min_value = 1;
        }
    }

    if((IsCheckpoint || CheckpointNoGate || CPfull) && gameBlock.WaypointSpecialProperty !is null) {
        if (CPfull) {
            if (gameBlock.WaypointSpecialProperty.Tag == 'LinkedCheckpoint') {
                return 2;
            } else if (gameBlock.WaypointSpecialProperty.Tag == 'Checkpoint') {
                min_value = 1;
            }
        } else if (gameBlock.WaypointSpecialProperty.Tag == 'Checkpoint' || gameBlock.WaypointSpecialProperty.Tag == 'LinkedCheckpoint') {
            if (IsCheckpoint) {
                return 2;
            }
            min_value = 1;
        }
    } else if (CPfull) {
        if (HasCheckpoint_Blocks.Find(name) >= 0) {
            return 2;
        }
        if ((name.EndsWith('ToRoadTech') || name.EndsWith('ToRoadWater')) && name.StartsWith('Platform')) {
            min_value = 1;
        }
    }
    if (CheckpointNoGate) {
        if (Boosters) {
            if (EffectBlocks) {
                if (name.Contains('Special')) {
                    return 2;
                }
            } else if (name.Contains('SpecialTurbo') || name.Contains('SpecialBoost')) {
                return 2;
            }
        } else if (EffectBlocks) {
            if (name.Contains('Special') && !(name.Contains('SpecialTurbo') || name.Contains('SpecialBoost'))) {
                return 2;
            }
        }
        return 1;
    } else if (Boosters) {
        if (EffectBlocks) {
            if (name.Contains('Special')) {
                return 2;
            }
        } else if (name.Contains('SpecialTurbo') || name.Contains('SpecialBoost')) {
            return 2;
        }
    } else if (EffectBlocks) {
        if (name.Contains('Special') && !(name.Contains('SpecialTurbo') || name.Contains('SpecialBoost'))) {
            return 2;
        }
    }
    if (Hole) {
        if (Hole_Blocks.Find(name) >= 0) {
            return 2;
        }
    }
    if (PoolHunter) {
        if (name.StartsWith('TrackWallWater') || name.StartsWith('DecoWallWater') || name.StartsWith('Water')) {
            min_value = 1;
        } else if (name.StartsWith('PlatformWater') || name.StartsWith('RoadWater')) {
            min_value = 1;
        }
    }
    if (Manslaughter) {
        if (name.StartsWith('Stand')) {
            min_value = 1;
        }
    }
    return min_value;
}

uint ShouldSaveItem (CGameCtnAnchoredObject@ item) {
    string name = item.ItemModel.Name;        
    if (item.ItemModel.IdName.EndsWith('.Item.Gbx')) {
        return 1;
    }
    if (ItemPlastic) {
        if (name.StartsWith('Inflatable')) {
            return 2;
        }
    }
    uint min_value = 0;
    if((IsCheckpoint || CheckpointNoGate || CPfull) && item.WaypointSpecialProperty !is null) {
        if (CPfull) {
            if (item.WaypointSpecialProperty.Tag == 'LinkedCheckpoint') {
                return 2;
            } else if (item.WaypointSpecialProperty.Tag == 'Checkpoint') {
                min_value = 1;
            }
        } else if (item.WaypointSpecialProperty.Tag == 'Checkpoint' || item.WaypointSpecialProperty.Tag == 'LinkedCheckpoint') {
            if (IsCheckpoint) {
                return 2;
            }
            min_value = 1;
        }
    }
    if (Boosters) {
        if (name.StartsWith('GateSpecial')) {
            if (EffectBlocks) {
                return 2;
            } else if (name.Contains('Turbo') || name.Contains('Boost')) {
                return 2;
            }
        }
    } else if (EffectBlocks) {
        if (name.StartsWith('GateSpecial') && !(name.Contains('Turbo') || name.Contains('Boost'))) {
            return 2;
        }
    }
    return min_value;
}
